# coding: utf-8

"""
    Lists

    CRUD operations to manage lists and list memberships  # noqa: E501

    The version of the OpenAPI document: v3
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from hubspot.crm.lists.configuration import Configuration


class PublicAssociationInListFilter(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "filter_type": "str",
        "coalescing_refine_by": "PublicEventAnalyticsFilterCoalescingRefineBy",
        "operator": "str",
        "list_id": "int",
        "to_object_type_id": "str",
        "association_type_id": "int",
        "association_category": "str",
        "to_object_type": "str",
    }

    attribute_map = {
        "filter_type": "filterType",
        "coalescing_refine_by": "coalescingRefineBy",
        "operator": "operator",
        "list_id": "listId",
        "to_object_type_id": "toObjectTypeId",
        "association_type_id": "associationTypeId",
        "association_category": "associationCategory",
        "to_object_type": "toObjectType",
    }

    def __init__(
        self,
        filter_type="ASSOCIATION",
        coalescing_refine_by=None,
        operator=None,
        list_id=None,
        to_object_type_id=None,
        association_type_id=None,
        association_category=None,
        to_object_type=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """PublicAssociationInListFilter - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._filter_type = None
        self._coalescing_refine_by = None
        self._operator = None
        self._list_id = None
        self._to_object_type_id = None
        self._association_type_id = None
        self._association_category = None
        self._to_object_type = None
        self.discriminator = None

        self.filter_type = filter_type
        self.coalescing_refine_by = coalescing_refine_by
        self.operator = operator
        self.list_id = list_id
        if to_object_type_id is not None:
            self.to_object_type_id = to_object_type_id
        self.association_type_id = association_type_id
        self.association_category = association_category
        if to_object_type is not None:
            self.to_object_type = to_object_type

    @property
    def filter_type(self):
        """Gets the filter_type of this PublicAssociationInListFilter.  # noqa: E501


        :return: The filter_type of this PublicAssociationInListFilter.  # noqa: E501
        :rtype: str
        """
        return self._filter_type

    @filter_type.setter
    def filter_type(self, filter_type):
        """Sets the filter_type of this PublicAssociationInListFilter.


        :param filter_type: The filter_type of this PublicAssociationInListFilter.  # noqa: E501
        :type filter_type: str
        """
        if self.local_vars_configuration.client_side_validation and filter_type is None:  # noqa: E501
            raise ValueError("Invalid value for `filter_type`, must not be `None`")  # noqa: E501
        allowed_values = ["ASSOCIATION"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and filter_type not in allowed_values:  # noqa: E501
            raise ValueError("Invalid value for `filter_type` ({0}), must be one of {1}".format(filter_type, allowed_values))  # noqa: E501

        self._filter_type = filter_type

    @property
    def coalescing_refine_by(self):
        """Gets the coalescing_refine_by of this PublicAssociationInListFilter.  # noqa: E501


        :return: The coalescing_refine_by of this PublicAssociationInListFilter.  # noqa: E501
        :rtype: PublicEventAnalyticsFilterCoalescingRefineBy
        """
        return self._coalescing_refine_by

    @coalescing_refine_by.setter
    def coalescing_refine_by(self, coalescing_refine_by):
        """Sets the coalescing_refine_by of this PublicAssociationInListFilter.


        :param coalescing_refine_by: The coalescing_refine_by of this PublicAssociationInListFilter.  # noqa: E501
        :type coalescing_refine_by: PublicEventAnalyticsFilterCoalescingRefineBy
        """
        if self.local_vars_configuration.client_side_validation and coalescing_refine_by is None:  # noqa: E501
            raise ValueError("Invalid value for `coalescing_refine_by`, must not be `None`")  # noqa: E501

        self._coalescing_refine_by = coalescing_refine_by

    @property
    def operator(self):
        """Gets the operator of this PublicAssociationInListFilter.  # noqa: E501


        :return: The operator of this PublicAssociationInListFilter.  # noqa: E501
        :rtype: str
        """
        return self._operator

    @operator.setter
    def operator(self, operator):
        """Sets the operator of this PublicAssociationInListFilter.


        :param operator: The operator of this PublicAssociationInListFilter.  # noqa: E501
        :type operator: str
        """
        if self.local_vars_configuration.client_side_validation and operator is None:  # noqa: E501
            raise ValueError("Invalid value for `operator`, must not be `None`")  # noqa: E501

        self._operator = operator

    @property
    def list_id(self):
        """Gets the list_id of this PublicAssociationInListFilter.  # noqa: E501


        :return: The list_id of this PublicAssociationInListFilter.  # noqa: E501
        :rtype: int
        """
        return self._list_id

    @list_id.setter
    def list_id(self, list_id):
        """Sets the list_id of this PublicAssociationInListFilter.


        :param list_id: The list_id of this PublicAssociationInListFilter.  # noqa: E501
        :type list_id: int
        """
        if self.local_vars_configuration.client_side_validation and list_id is None:  # noqa: E501
            raise ValueError("Invalid value for `list_id`, must not be `None`")  # noqa: E501

        self._list_id = list_id

    @property
    def to_object_type_id(self):
        """Gets the to_object_type_id of this PublicAssociationInListFilter.  # noqa: E501


        :return: The to_object_type_id of this PublicAssociationInListFilter.  # noqa: E501
        :rtype: str
        """
        return self._to_object_type_id

    @to_object_type_id.setter
    def to_object_type_id(self, to_object_type_id):
        """Sets the to_object_type_id of this PublicAssociationInListFilter.


        :param to_object_type_id: The to_object_type_id of this PublicAssociationInListFilter.  # noqa: E501
        :type to_object_type_id: str
        """

        self._to_object_type_id = to_object_type_id

    @property
    def association_type_id(self):
        """Gets the association_type_id of this PublicAssociationInListFilter.  # noqa: E501


        :return: The association_type_id of this PublicAssociationInListFilter.  # noqa: E501
        :rtype: int
        """
        return self._association_type_id

    @association_type_id.setter
    def association_type_id(self, association_type_id):
        """Sets the association_type_id of this PublicAssociationInListFilter.


        :param association_type_id: The association_type_id of this PublicAssociationInListFilter.  # noqa: E501
        :type association_type_id: int
        """
        if self.local_vars_configuration.client_side_validation and association_type_id is None:  # noqa: E501
            raise ValueError("Invalid value for `association_type_id`, must not be `None`")  # noqa: E501

        self._association_type_id = association_type_id

    @property
    def association_category(self):
        """Gets the association_category of this PublicAssociationInListFilter.  # noqa: E501


        :return: The association_category of this PublicAssociationInListFilter.  # noqa: E501
        :rtype: str
        """
        return self._association_category

    @association_category.setter
    def association_category(self, association_category):
        """Sets the association_category of this PublicAssociationInListFilter.


        :param association_category: The association_category of this PublicAssociationInListFilter.  # noqa: E501
        :type association_category: str
        """
        if self.local_vars_configuration.client_side_validation and association_category is None:  # noqa: E501
            raise ValueError("Invalid value for `association_category`, must not be `None`")  # noqa: E501

        self._association_category = association_category

    @property
    def to_object_type(self):
        """Gets the to_object_type of this PublicAssociationInListFilter.  # noqa: E501


        :return: The to_object_type of this PublicAssociationInListFilter.  # noqa: E501
        :rtype: str
        """
        return self._to_object_type

    @to_object_type.setter
    def to_object_type(self, to_object_type):
        """Sets the to_object_type of this PublicAssociationInListFilter.


        :param to_object_type: The to_object_type of this PublicAssociationInListFilter.  # noqa: E501
        :type to_object_type: str
        """

        self._to_object_type = to_object_type

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(map(lambda item: (item[0], convert(item[1])), value.items()))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PublicAssociationInListFilter):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PublicAssociationInListFilter):
            return True

        return self.to_dict() != other.to_dict()
