# coding: utf-8

"""
    Lists

    CRUD operations to manage lists and list memberships  # noqa: E501

    The version of the OpenAPI document: v3
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from hubspot.crm.lists.configuration import Configuration


class PublicTimePointOperation(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "operation_type": "str",
        "operator": "str",
        "include_objects_with_no_value_set": "bool",
        "time_point": "PublicTimePointOperationTimePoint",
        "endpoint_behavior": "str",
        "property_parser": "str",
        "type": "str",
    }

    attribute_map = {
        "operation_type": "operationType",
        "operator": "operator",
        "include_objects_with_no_value_set": "includeObjectsWithNoValueSet",
        "time_point": "timePoint",
        "endpoint_behavior": "endpointBehavior",
        "property_parser": "propertyParser",
        "type": "type",
    }

    def __init__(
        self,
        operation_type="TIME_POINT",
        operator=None,
        include_objects_with_no_value_set=None,
        time_point=None,
        endpoint_behavior=None,
        property_parser=None,
        type=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """PublicTimePointOperation - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._operation_type = None
        self._operator = None
        self._include_objects_with_no_value_set = None
        self._time_point = None
        self._endpoint_behavior = None
        self._property_parser = None
        self._type = None
        self.discriminator = None

        self.operation_type = operation_type
        self.operator = operator
        self.include_objects_with_no_value_set = include_objects_with_no_value_set
        self.time_point = time_point
        if endpoint_behavior is not None:
            self.endpoint_behavior = endpoint_behavior
        if property_parser is not None:
            self.property_parser = property_parser
        self.type = type

    @property
    def operation_type(self):
        """Gets the operation_type of this PublicTimePointOperation.  # noqa: E501


        :return: The operation_type of this PublicTimePointOperation.  # noqa: E501
        :rtype: str
        """
        return self._operation_type

    @operation_type.setter
    def operation_type(self, operation_type):
        """Sets the operation_type of this PublicTimePointOperation.


        :param operation_type: The operation_type of this PublicTimePointOperation.  # noqa: E501
        :type operation_type: str
        """
        if self.local_vars_configuration.client_side_validation and operation_type is None:  # noqa: E501
            raise ValueError("Invalid value for `operation_type`, must not be `None`")  # noqa: E501
        allowed_values = ["TIME_POINT"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and operation_type not in allowed_values:  # noqa: E501
            raise ValueError("Invalid value for `operation_type` ({0}), must be one of {1}".format(operation_type, allowed_values))  # noqa: E501

        self._operation_type = operation_type

    @property
    def operator(self):
        """Gets the operator of this PublicTimePointOperation.  # noqa: E501


        :return: The operator of this PublicTimePointOperation.  # noqa: E501
        :rtype: str
        """
        return self._operator

    @operator.setter
    def operator(self, operator):
        """Sets the operator of this PublicTimePointOperation.


        :param operator: The operator of this PublicTimePointOperation.  # noqa: E501
        :type operator: str
        """
        if self.local_vars_configuration.client_side_validation and operator is None:  # noqa: E501
            raise ValueError("Invalid value for `operator`, must not be `None`")  # noqa: E501

        self._operator = operator

    @property
    def include_objects_with_no_value_set(self):
        """Gets the include_objects_with_no_value_set of this PublicTimePointOperation.  # noqa: E501


        :return: The include_objects_with_no_value_set of this PublicTimePointOperation.  # noqa: E501
        :rtype: bool
        """
        return self._include_objects_with_no_value_set

    @include_objects_with_no_value_set.setter
    def include_objects_with_no_value_set(self, include_objects_with_no_value_set):
        """Sets the include_objects_with_no_value_set of this PublicTimePointOperation.


        :param include_objects_with_no_value_set: The include_objects_with_no_value_set of this PublicTimePointOperation.  # noqa: E501
        :type include_objects_with_no_value_set: bool
        """
        if self.local_vars_configuration.client_side_validation and include_objects_with_no_value_set is None:  # noqa: E501
            raise ValueError("Invalid value for `include_objects_with_no_value_set`, must not be `None`")  # noqa: E501

        self._include_objects_with_no_value_set = include_objects_with_no_value_set

    @property
    def time_point(self):
        """Gets the time_point of this PublicTimePointOperation.  # noqa: E501


        :return: The time_point of this PublicTimePointOperation.  # noqa: E501
        :rtype: PublicTimePointOperationTimePoint
        """
        return self._time_point

    @time_point.setter
    def time_point(self, time_point):
        """Sets the time_point of this PublicTimePointOperation.


        :param time_point: The time_point of this PublicTimePointOperation.  # noqa: E501
        :type time_point: PublicTimePointOperationTimePoint
        """
        if self.local_vars_configuration.client_side_validation and time_point is None:  # noqa: E501
            raise ValueError("Invalid value for `time_point`, must not be `None`")  # noqa: E501

        self._time_point = time_point

    @property
    def endpoint_behavior(self):
        """Gets the endpoint_behavior of this PublicTimePointOperation.  # noqa: E501


        :return: The endpoint_behavior of this PublicTimePointOperation.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_behavior

    @endpoint_behavior.setter
    def endpoint_behavior(self, endpoint_behavior):
        """Sets the endpoint_behavior of this PublicTimePointOperation.


        :param endpoint_behavior: The endpoint_behavior of this PublicTimePointOperation.  # noqa: E501
        :type endpoint_behavior: str
        """

        self._endpoint_behavior = endpoint_behavior

    @property
    def property_parser(self):
        """Gets the property_parser of this PublicTimePointOperation.  # noqa: E501


        :return: The property_parser of this PublicTimePointOperation.  # noqa: E501
        :rtype: str
        """
        return self._property_parser

    @property_parser.setter
    def property_parser(self, property_parser):
        """Sets the property_parser of this PublicTimePointOperation.


        :param property_parser: The property_parser of this PublicTimePointOperation.  # noqa: E501
        :type property_parser: str
        """

        self._property_parser = property_parser

    @property
    def type(self):
        """Gets the type of this PublicTimePointOperation.  # noqa: E501


        :return: The type of this PublicTimePointOperation.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PublicTimePointOperation.


        :param type: The type of this PublicTimePointOperation.  # noqa: E501
        :type type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(map(lambda item: (item[0], convert(item[1])), value.items()))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PublicTimePointOperation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PublicTimePointOperation):
            return True

        return self.to_dict() != other.to_dict()
