# coding: utf-8

"""
    Lists

    CRUD operations to manage lists and list memberships  # noqa: E501

    The version of the OpenAPI document: v3
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from hubspot.crm.lists.configuration import Configuration


class PublicTodayReference(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"reference_type": "str", "hour": "int", "minute": "int", "second": "int", "millisecond": "int"}

    attribute_map = {"reference_type": "referenceType", "hour": "hour", "minute": "minute", "second": "second", "millisecond": "millisecond"}

    def __init__(self, reference_type="TODAY", hour=None, minute=None, second=None, millisecond=None, local_vars_configuration=None):  # noqa: E501
        """PublicTodayReference - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._reference_type = None
        self._hour = None
        self._minute = None
        self._second = None
        self._millisecond = None
        self.discriminator = None

        self.reference_type = reference_type
        if hour is not None:
            self.hour = hour
        if minute is not None:
            self.minute = minute
        if second is not None:
            self.second = second
        if millisecond is not None:
            self.millisecond = millisecond

    @property
    def reference_type(self):
        """Gets the reference_type of this PublicTodayReference.  # noqa: E501


        :return: The reference_type of this PublicTodayReference.  # noqa: E501
        :rtype: str
        """
        return self._reference_type

    @reference_type.setter
    def reference_type(self, reference_type):
        """Sets the reference_type of this PublicTodayReference.


        :param reference_type: The reference_type of this PublicTodayReference.  # noqa: E501
        :type reference_type: str
        """
        if self.local_vars_configuration.client_side_validation and reference_type is None:  # noqa: E501
            raise ValueError("Invalid value for `reference_type`, must not be `None`")  # noqa: E501
        allowed_values = ["TODAY"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and reference_type not in allowed_values:  # noqa: E501
            raise ValueError("Invalid value for `reference_type` ({0}), must be one of {1}".format(reference_type, allowed_values))  # noqa: E501

        self._reference_type = reference_type

    @property
    def hour(self):
        """Gets the hour of this PublicTodayReference.  # noqa: E501


        :return: The hour of this PublicTodayReference.  # noqa: E501
        :rtype: int
        """
        return self._hour

    @hour.setter
    def hour(self, hour):
        """Sets the hour of this PublicTodayReference.


        :param hour: The hour of this PublicTodayReference.  # noqa: E501
        :type hour: int
        """

        self._hour = hour

    @property
    def minute(self):
        """Gets the minute of this PublicTodayReference.  # noqa: E501


        :return: The minute of this PublicTodayReference.  # noqa: E501
        :rtype: int
        """
        return self._minute

    @minute.setter
    def minute(self, minute):
        """Sets the minute of this PublicTodayReference.


        :param minute: The minute of this PublicTodayReference.  # noqa: E501
        :type minute: int
        """

        self._minute = minute

    @property
    def second(self):
        """Gets the second of this PublicTodayReference.  # noqa: E501


        :return: The second of this PublicTodayReference.  # noqa: E501
        :rtype: int
        """
        return self._second

    @second.setter
    def second(self, second):
        """Sets the second of this PublicTodayReference.


        :param second: The second of this PublicTodayReference.  # noqa: E501
        :type second: int
        """

        self._second = second

    @property
    def millisecond(self):
        """Gets the millisecond of this PublicTodayReference.  # noqa: E501


        :return: The millisecond of this PublicTodayReference.  # noqa: E501
        :rtype: int
        """
        return self._millisecond

    @millisecond.setter
    def millisecond(self, millisecond):
        """Sets the millisecond of this PublicTodayReference.


        :param millisecond: The millisecond of this PublicTodayReference.  # noqa: E501
        :type millisecond: int
        """

        self._millisecond = millisecond

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(lambda x: convert(x), value))
            elif isinstance(value, dict):
                result[attr] = dict(map(lambda item: (item[0], convert(item[1])), value.items()))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PublicTodayReference):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PublicTodayReference):
            return True

        return self.to_dict() != other.to_dict()
